# Tornado Cash Smart Contracts

[Codes behind Tornado.Cash functioning](https://github.com/tornadocash) - smart contacts, circuits & toolchain - are fully **open sourced.** This page regroups all information regarding Tornado Cash smart contracts.

## Smart Contracts Adresses

### Tornado Cash Classic - Pools Contracts

* Ethereum Mainnet

| Contract       | Address                                                                                                                                                                                                                                                                     |
| -------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| 0.1 ETH        | [0x12d66f87a04a9e220743712ce6d9bb1b5616b8fc](https://etherscan.io/address/0x12d66f87a04a9e220743712ce6d9bb1b5616b8fc)                                                                                                                                                       |
| 1 ETH          | [0x47ce0c6ed5b0ce3d3a51fdb1c52dc66a7c3c2936](https://etherscan.io/address/0x47ce0c6ed5b0ce3d3a51fdb1c52dc66a7c3c2936)                                                                                                                                                       |
| 10 ETH         | [0x910cbd523d972eb0a6f4cae4618ad62622b39dbf](https://etherscan.io/address/0x910cbd523d972eb0a6f4cae4618ad62622b39dbf)                                                                                                                                                       |
| 100 ETH        | [0xa160cdab225685da1d56aa342ad8841c3b53f291](https://etherscan.io/address/0xa160cdab225685da1d56aa342ad8841c3b53f291)                                                                                                                                                       |
| 100 DAI        | [0xd4b88df4d29f5cedd6857912842cff3b20c8cfa3](https://etherscan.io/address/0xd4b88df4d29f5cedd6857912842cff3b20c8cfa3)                                                                                                                                                       |
| 1,000 DAI      | [0xfd8610d20aa15b7b2e3be39b396a1bc3516c7144](https://etherscan.io/address/0xfd8610d20aa15b7b2e3be39b396a1bc3516c7144)                                                                                                                                                       |
| 10,000 DAI     | [0](https://etherscan.io/address/0x07687e702b410Fa43f4cB4Af7FA097918ffD2730)[x](https://etherscan.io/address/0xfd8610d20aa15b7b2e3be39b396a1bc3516c7144)[07687e702b410Fa43f4cB4Af7FA097918ffD2730](https://etherscan.io/address/0x07687e702b410Fa43f4cB4Af7FA097918ffD2730) |
| 100,000 DAI    | [0](https://etherscan.io/address/0x23773E65ed146A459791799d01336DB287f25334)[x](https://etherscan.io/address/0xfd8610d20aa15b7b2e3be39b396a1bc3516c7144)[23773E65ed146A459791799d01336DB287f25334](https://etherscan.io/address/0x23773E65ed146A459791799d01336DB287f25334) |
| 5,000 cDAI     | [0x22aaA7720ddd5388A3c0A3333430953C68f1849b](https://etherscan.io/address/0x22aaA7720ddd5388A3c0A3333430953C68f1849b)                                                                                                                                                       |
| 50,000 cDAI    | [0x03893a7c7463AE47D46bc7f091665f1893656003](https://etherscan.io/address/0x03893a7c7463AE47D46bc7f091665f1893656003)                                                                                                                                                       |
| 500,000 cDAI   | [0x2717c5e28cf931547B621a5dddb772Ab6A35B701](https://etherscan.io/address/0x2717c5e28cf931547B621a5dddb772Ab6A35B701)                                                                                                                                                       |
| 5,000,000 cDAI | [0xD21be7248e0197Ee08E0c20D4a96DEBdaC3D20Af](https://etherscan.io/address/0xD21be7248e0197Ee08E0c20D4a96DEBdaC3D20Af)                                                                                                                                                       |
| 100 USDC       | [0x4736dCf1b7A3d580672CcE6E7c65cd5cc9cFBa9D](https://etherscan.io/address/0x4736dCf1b7A3d580672CcE6E7c65cd5cc9cFBa9D)                                                                                                                                                       |
| 1,000 USDC     | [0xd96f2B1c14Db8458374d9Aca76E26c3D18364307](https://etherscan.io/address/0xd96f2B1c14Db8458374d9Aca76E26c3D18364307)                                                                                                                                                       |
| 100 USDT       | [0x169AD27A470D064DEDE56a2D3ff727986b15D52B](https://etherscan.io/address/0x169AD27A470D064DEDE56a2D3ff727986b15D52B)                                                                                                                                                       |
| 1,000 USDT     | [0x0836222F2B2B24A3F36f98668Ed8F0B38D1a872f](https://etherscan.io/address/0x0836222F2B2B24A3F36f98668Ed8F0B38D1a872f)                                                                                                                                                       |
| 0.1 WBTC       | [0x178169B423a011fff22B9e3F3abeA13414dDD0F1](https://etherscan.io/address/0x178169B423a011fff22B9e3F3abeA13414dDD0F1)                                                                                                                                                       |
| 1 WBTC         | [0x610B717796ad172B316836AC95a2ffad065CeaB4](https://etherscan.io/address/0x610B717796ad172B316836AC95a2ffad065CeaB4)                                                                                                                                                       |
| 10 WBTC        | [0xbB93e510BbCD0B7beb5A853875f9eC60275CF498](https://etherscan.io/address/0xbB93e510BbCD0B7beb5A853875f9eC60275CF498)                                                                                                                                                       |

* Arbitrum

| Contract | Address                                                                                                              |
| -------- | -------------------------------------------------------------------------------------------------------------------- |
| 0.1 ETH  | [0x84443CFd09A48AF6eF360C6976C5392aC5023a1F](https://arbiscan.io/address/0x84443CFd09A48AF6eF360C6976C5392aC5023a1F) |
| 1 ETH    | [0xd47438C816c9E7f2E2888E060936a499Af9582b3](https://arbiscan.io/address/0xd47438C816c9E7f2E2888E060936a499Af9582b3) |
| 10 ETH   | [0x330bdFADE01eE9bF63C209Ee33102DD334618e0a](https://arbiscan.io/address/0x330bdFADE01eE9bF63C209Ee33102DD334618e0a) |
| 100 ETH  | [0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD](https://arbiscan.io/address/0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD) |

* Optimism

| Contract | Address                                                                                                                          |
| -------- | -------------------------------------------------------------------------------------------------------------------------------- |
| 0.1 ETH  | [0x84443CFd09A48AF6eF360C6976C5392aC5023a1F](https://optimistic.etherscan.io/address/0x84443CFd09A48AF6eF360C6976C5392aC5023a1F) |
| 1 ETH    | [0xd47438C816c9E7f2E2888E060936a499Af9582b3](https://optimistic.etherscan.io/address/0xd47438C816c9E7f2E2888E060936a499Af9582b3) |
| 10 ETH   | [0x330bdFADE01eE9bF63C209Ee33102DD334618e0a](https://optimistic.etherscan.io/address/0x330bdFADE01eE9bF63C209Ee33102DD334618e0a) |
| 100 ETH  | [0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD](https://optimistic.etherscan.io/address/0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD) |

* BSC

| Contract | Address                                                                                                              |
| -------- | -------------------------------------------------------------------------------------------------------------------- |
| 0.1 BNB  | [0x84443CFd09A48AF6eF360C6976C5392aC5023a1F](https://bscscan.com/address/0x84443CFd09A48AF6eF360C6976C5392aC5023a1F) |
| 1 BNB    | [0xd47438C816c9E7f2E2888E060936a499Af9582b3](https://bscscan.com/address/0xd47438C816c9E7f2E2888E060936a499Af9582b3) |
| 10 BNB   | [0x330bdFADE01eE9bF63C209Ee33102DD334618e0a](https://bscscan.com/address/0x330bdFADE01eE9bF63C209Ee33102DD334618e0a) |
| 100 BNB  | [0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD](https://bscscan.com/address/0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD) |

* xDAI

| Contract     | Address                                                                                                                                           |
| ------------ | ------------------------------------------------------------------------------------------------------------------------------------------------- |
| 100 xDAI     | [0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD](https://blockscout.com/xdai/mainnet/address/0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD/transactions) |
| 1,000 xDAI   | [0xdf231d99Ff8b6c6CBF4E9B9a945CBAcEF9339178](https://blockscout.com/xdai/mainnet/address/0xdf231d99Ff8b6c6CBF4E9B9a945CBAcEF9339178/transactions) |
| 10,000 xDAI  | [0xaf4c0B70B2Ea9FB7487C7CbB37aDa259579fe040](https://blockscout.com/xdai/mainnet/address/0xaf4c0B70B2Ea9FB7487C7CbB37aDa259579fe040/transactions) |
| 100,000 xDAI | [0xa5C2254e4253490C54cef0a4347fddb8f75A4998](https://blockscout.com/xdai/mainnet/address/0xa5C2254e4253490C54cef0a4347fddb8f75A4998/transactions) |

* MATIC

| Contract      | Address                                                                                                                  |
| ------------- | ------------------------------------------------------------------------------------------------------------------------ |
| 100 MATIC     | [0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD](https://polygonscan.com/address/0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD) |
| 1,000 MATIC   | [0xdf231d99Ff8b6c6CBF4E9B9a945CBAcEF9339178](https://polygonscan.com/address/0xdf231d99Ff8b6c6CBF4E9B9a945CBAcEF9339178) |
| 10,000 MATIC  | [0xaf4c0B70B2Ea9FB7487C7CbB37aDa259579fe040](https://polygonscan.com/address/0xaf4c0B70B2Ea9FB7487C7CbB37aDa259579fe040) |
| 100,000 MATIC | [0xa5C2254e4253490C54cef0a4347fddb8f75A4998](https://polygonscan.com/address/0xa5C2254e4253490C54cef0a4347fddb8f75A4998) |

* AVAX

| Contract | Address                                                                                                               |
| -------- | --------------------------------------------------------------------------------------------------------------------- |
| 10 AVAX  | [0x330bdFADE01eE9bF63C209Ee33102DD334618e0a](https://snowtrace.io/address/0x330bdFADE01eE9bF63C209Ee33102DD334618e0a) |
| 100 AVAX | [0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD](https://snowtrace.io/address/0x1E34A77868E19A6647b1f2F47B51ed72dEDE95DD) |
| 500 AVAX | [0xaf8d1839c3c67cf571aa74B5c12398d4901147B3](https://snowtrace.io/address/0xaf8d1839c3c67cf571aa74B5c12398d4901147B3) |

* Goerli

| Contract       | Address                                                                                                                      |
| -------------- | ---------------------------------------------------------------------------------------------------------------------------- |
| 0.1 ETH        | [0x6Bf694a291DF3FeC1f7e69701E3ab6c592435Ae7](https://goerli.etherscan.io/address/0x6Bf694a291DF3FeC1f7e69701E3ab6c592435Ae7) |
| 1 ETH          | [0x3aac1cC67c2ec5Db4eA850957b967Ba153aD6279](https://goerli.etherscan.io/address/0x3aac1cC67c2ec5Db4eA850957b967Ba153aD6279) |
| 10 ETH         | [0x723B78e67497E85279CB204544566F4dC5d2acA0](https://goerli.etherscan.io/address/0x723B78e67497E85279CB204544566F4dC5d2acA0) |
| 100 ETH        | [0x0E3A09dDA6B20aFbB34aC7cD4A6881493f3E7bf7](https://goerli.etherscan.io/address/0x0E3A09dDA6B20aFbB34aC7cD4A6881493f3E7bf7) |
| 100 DAI        | [0x76D85B4C0Fc497EeCc38902397aC608000A06607](https://goerli.etherscan.io/address/0x76D85B4C0Fc497EeCc38902397aC608000A06607) |
| 1,000 DAI      | [0xCC84179FFD19A1627E79F8648d09e095252Bc418](https://goerli.etherscan.io/address/0xCC84179FFD19A1627E79F8648d09e095252Bc418) |
| 10,000 DAI     | [0xD5d6f8D9e784d0e26222ad3834500801a68D027D](https://goerli.etherscan.io/address/0xD5d6f8D9e784d0e26222ad3834500801a68D027D) |
| 100,000 DAI    | [0x407CcEeaA7c95d2FE2250Bf9F2c105aA7AAFB512](https://goerli.etherscan.io/address/0x407CcEeaA7c95d2FE2250Bf9F2c105aA7AAFB512) |
| 5,000 cDAI     | [0x833481186f16Cece3f1Eeea1a694c42034c3a0dB](https://goerli.etherscan.io/address/0x833481186f16Cece3f1Eeea1a694c42034c3a0dB) |
| 50,000 cDAI    | [0xd8D7DE3349ccaA0Fde6298fe6D7b7d0d34586193](https://goerli.etherscan.io/address/0xd8D7DE3349ccaA0Fde6298fe6D7b7d0d34586193) |
| 500,000 cDAI   | [0x8281Aa6795aDE17C8973e1aedcA380258Bc124F9](https://goerli.etherscan.io/address/0x8281Aa6795aDE17C8973e1aedcA380258Bc124F9) |
| 5,000,000 cDAI | [0x57b2B8c82F065de8Ef5573f9730fC1449B403C9f](https://goerli.etherscan.io/address/0x57b2B8c82F065de8Ef5573f9730fC1449B403C9f) |
| 100 USDC       | [0x05E0b5B40B7b66098C2161A5EE11C5740A3A7C45](https://goerli.etherscan.io/address/0x05E0b5B40B7b66098C2161A5EE11C5740A3A7C45) |
| 1,000 USDC     | [0x23173fE8b96A4Ad8d2E17fB83EA5dcccdCa1Ae52](https://goerli.etherscan.io/address/0x23173fE8b96A4Ad8d2E17fB83EA5dcccdCa1Ae52) |
| 100 USDT       | [0x538Ab61E8A9fc1b2f93b3dd9011d662d89bE6FE6](https://goerli.etherscan.io/address/0x538Ab61E8A9fc1b2f93b3dd9011d662d89bE6FE6) |
| 1,000 USDT     | [0x94Be88213a387E992Dd87DE56950a9aef34b9448](https://goerli.etherscan.io/address/0x94Be88213a387E992Dd87DE56950a9aef34b9448) |
| 0.1 WBTC       | [0x242654336ca2205714071898f67E254EB49ACdCe](https://goerli.etherscan.io/address/0x242654336ca2205714071898f67E254EB49ACdCe) |
| 1 WBTC         | [0x776198CCF446DFa168347089d7338879273172cF](https://goerli.etherscan.io/address/0x776198CCF446DFa168347089d7338879273172cF) |
| 10 WBTC        | [0xeDC5d01286f99A066559F60a585406f3878a033e](https://goerli.etherscan.io/address/0xeDC5d01286f99A066559F60a585406f3878a033e) |

### Tornado Cash Nova - Pool contracts (beta)

| Contract             | Address                                                                                                                                           |
| -------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------- |
| Contract             | [0xD692Fd2D0b2Fbd2e52CFa5B5b9424bC981C30696](https://blockscout.com/xdai/mainnet/address/0xD692Fd2D0b2Fbd2e52CFa5B5b9424bC981C30696/transactions) |
| L1 Omnibridge Helper | [0xca0840578f57fe71599d29375e16783424023357](https://etherscan.io/address/0xca0840578f57fe71599d29375e16783424023357)                             |
| Verifier 2           | [0xDF3A408c53E5078af6e8fb2A85088D46Ee09A61b](https://blockscout.com/xdai/mainnet/address/0xDF3A408c53E5078af6e8fb2A85088D46Ee09A61b/transactions) |
| Verifier 16          | [0x743494b60097A2230018079c02fe21a7B687EAA5](https://blockscout.com/xdai/mainnet/address/0x743494b60097A2230018079c02fe21a7B687EAA5/transactions) |
| Hasher               | [0x94C92F096437ab9958fC0A37F09348f30389Ae79](https://blockscout.com/xdai/mainnet/address/0x94C92F096437ab9958fC0A37F09348f30389Ae79/transactions) |

### Governance Contracts:

| Contract                           | Address                                                                                                                          |
| ---------------------------------- | -------------------------------------------------------------------------------------------------------------------------------- |
| Governance Contract                | [0x5efda50f22d34f262c29268506c5fa42cb56a1ce](https://etherscan.io/address/0x5efda50f22d34f262c29268506c5fa42cb56a1ce)            |
| Governance Vault (for locked TORN) | [0x2f50508a8a3d323b91336fa3ea6ae50e55f32185](https://etherscan.io/address/0x2f50508a8a3d323b91336fa3ea6ae50e55f32185#tokentxns)  |
| Deployer Contract                  | [0xCEe71753C9820f063b38FDbE4cFDAf1d3D928A80](https://etherscan.io/address/0xCEe71753C9820f063b38FDbE4cFDAf1d3D928A80)            |
| Governance Impl                    | [0xffbac21a641dcfe4552920138d90f3638b3c9fba](https://etherscan.io/address/0xffbac21a641dcfe4552920138d90f3638b3c9fba)            |
| Governance Vesting                 | [0x179f48c78f57a3a78f0608cc9197b8972921d1d2](https://etherscan.io/address/0x179f48c78f57a3a78f0608cc9197b8972921d1d2)            |
| Community Fund                     | [0xb04E030140b30C27bcdfaafFFA98C57d80eDa7B4](https://gnosis-safe.io/app/eth:0xb04E030140b30C27bcdfaafFFA98C57d80eDa7B4/balances) |
| TORN Token                         | [0x77777feddddffc19ff86db637967013e6c6a116c](https://etherscan.io/address/0x77777feddddffc19ff86db637967013e6c6a116c)            |
| Voucher TORN Token                 | [0x3efa30704d2b8bbac821307230376556cf8cc39e](https://etherscan.io/address/0x3efa30704d2b8bbac821307230376556cf8cc39e)            |
| Mining v2                          | [0x746aebc06d2ae31b71ac51429a19d54e797878e9](https://etherscan.io/address/0x746aebc06d2ae31b71ac51429a19d54e797878e9)            |

### Relayer Registry

| Contract                          | Address                                                                                                               |
| --------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| TornadoRooter                     | [0xd90e2f925DA726b50C4Ed8D0Fb90Ad053324F31b](https://etherscan.io/address/0xd90e2f925DA726b50C4Ed8D0Fb90Ad053324F31b) |
| Proxy of feeManagerContract       | [0x5f6c97C6AD7bdd0AE7E0Dd4ca33A4ED3fDabD4D7](https://etherscan.io/address/0x5f6c97C6AD7bdd0AE7E0Dd4ca33A4ED3fDabD4D7) |
| FeeManager                        | [0xf4B067dD14e95Bab89Be928c07Cb22E3c94E0DAA](https://etherscan.io/address/0xf4B067dD14e95Bab89Be928c07Cb22E3c94E0DAA) |
| Proxy of relayerRegistryContract  | [0x58E8dCC13BE9780fC42E8723D8EaD4CF46943dF2](https://etherscan.io/address/0x58E8dCC13BE9780fC42E8723D8EaD4CF46943dF2) |
| RelayerRegistry                   | [0x01e2919679362dFBC9ee1644Ba9C6da6D6245BB1](https://etherscan.io/address/0x01e2919679362dFBC9ee1644Ba9C6da6D6245BB1) |
| Proxy of stakingContract          | [0x2FC93484614a34f26F7970CBB94615bA109BB4bf](https://etherscan.io/address/0x2FC93484614a34f26F7970CBB94615bA109BB4bf) |
| TornadoStakingRewards             | [0x26903a5a198D571422b2b4EA08b56a37cbD68c89](https://etherscan.io/address/0x26903a5a198D571422b2b4EA08b56a37cbD68c89) |
| Proxy of instanceRegistryContract | [0xB20c66C4DE72433F3cE747b58B86830c459CA911](https://etherscan.io/address/0xB20c66C4DE72433F3cE747b58B86830c459CA911) |
| InstanceRegistry                  | [0x2573BAc39EBe2901B4389CD468F2872cF7767FAF](https://etherscan.io/address/0x2573BAc39EBe2901B4389CD468F2872cF7767FAF) |

### Other Contracts

| Contract             | Address                                                                                                               |
| -------------------- | --------------------------------------------------------------------------------------------------------------------- |
| Tornado.Cash Trees   | [0x527653ea119f3e6a1f5bd18fbf4714081d7b31ce](https://etherscan.io/address/0x527653ea119f3e6a1f5bd18fbf4714081d7b31ce) |
| Tree Update Verifier | [0x653477c392c16b0765603074f157314cc4f40c32](https://etherscan.io/address/0x653477c392c16b0765603074f157314cc4f40c32) |
| Reward Verifier      | [0x88fd245fedec4a936e700f9173454d1931b4c307](https://etherscan.io/address/0x88fd245fedec4a936e700f9173454d1931b4c307) |
| Withdraw Verifier    | [0x09193888b3f38c82dedfda55259a82c0e7de875e](https://etherscan.io/address/0x09193888b3f38c82dedfda55259a82c0e7de875e) |
| Reward Swap          | [0x5cab7692d4e94096462119ab7bf57319726eed2a](https://etherscan.io/address/0x5cab7692d4e94096462119ab7bf57319726eed2a) |
| Echoer               | [0x756c4628e57f7e7f8a459ec2752968360cf4d1aa](https://etherscan.io/address/0x756c4628e57f7e7f8a459ec2752968360cf4d1aa) |
| Proxy                | [0x722122df12d4e14e13ac3b6895a86e84145b6967](https://etherscan.io/address/0x722122df12d4e14e13ac3b6895a86e84145b6967) |
| Mixer 1              | [0x94a1b5cdb22c43faab4abeb5c74999895464ddaf](https://etherscan.io/address/0x94a1b5cdb22c43faab4abeb5c74999895464ddaf) |
| Mixer 2              | [0xb541fc07bc7619fd4062a54d96268525cbc6ffef](https://etherscan.io/address/0xb541fc07bc7619fd4062a54d96268525cbc6ffef) |
| Poseidon 2           | [0x94c92f096437ab9958fc0a37f09348f30389ae79](https://etherscan.io/address/0x94c92f096437ab9958fc0a37f09348f30389ae79) |
| Poseidon 3           | [0xd82ed8786d7c69dc7e052f7a542ab047971e73d2](https://etherscan.io/address/0xd82ed8786d7c69dc7e052f7a542ab047971e73d2) |
| Gitcoin Grants       | [0xdd4c48c0b24039969fc16d1cdf626eab821d3384](https://etherscan.io/address/0xdd4c48c0b24039969fc16d1cdf626eab821d3384) |

## GitHub links

* Tornado Cash core code:

{% embed url="https://github.com/tornadocash/tornado-core" %}

* Tornado Cash Command Line to make transactions in the protocol:

{% embed url="https://github.com/tornadocash/tornado-cli" %}

* To become a relayer for Tornado Cash:

{% embed url="https://github.com/tornadocash/tornado-relayer" %}

* Minified web UI for Tornado Cash protocol:

{% embed url="https://github.com/tornadocash/ui-minified" %}

* All about the TORN token:

{% embed url="https://github.com/tornadocash/torn-token" %}

* All about the anonymity mining program (this program has ended mid-December 2021):

{% embed url="https://github.com/tornadocash/tornado-anonymity-mining" %}

_Written by_ [_@ayefda_](https://torn.community/u/ayefda) _&_ [_@bt11ba_](https://torn.community/u/bt11ba/)
