# Logging In Tornado Cash Nova

Launched in December 2021, Tornado Cash Nova offers the freedom to choose customized amounts for transactions, as well as the ability to transfer tokens without leaving the anonymity pool. With such unique features, this new pool requires its own set of instructions.

Tornado Cash Nova (beta version) can be accessed through its own decentralized app at[ nova.tornadocash.eth.link](https://nova.tornadocash.eth.link).

![](https://i.imgur.com/F8pojDs.png)

First of all, welcome to Tornado Cash Nova pool & let’s discover how this brand new tool functions 🌪

## Log In <a href="#log-in-nova" id="log-in-nova"></a>

![](https://i.imgur.com/uHPTk13.png)

You can log into your Tornado Cash Nova account either by:

* **connecting the MetaMask Wallet** with the address linked to your Nova account,
* **using the Shielded Key** that was generated alongside the creation of your account.

Each account is connected to a unique **shielded address** (as well as a unique **shielded key**) that can both be used to log in & manage your balance within the Nova pool.

### Tornado Cash Nova Account <a href="#tornado-cash-nova-account" id="tornado-cash-nova-account"></a>

Logging into the Nova pool will allow you to:

* **check your shielded balance** which represents the amount of tokens currently owned in the Nova pool,
* **fund your balance** with further tokens,
* **transfer the custody of tokens** to another shielded address registered to the pool,
* **withdraw any desired amount of tokens** through the destination address of your chosing.

Only those who have access to your Metamask wallet or to your Shielded key will be able to access these informations regarding your account (i.e. your shielded balance).\
⚠️ Be aware of which information you share with whom.

### MetaMask Wallet <a href="#metamask-wallet" id="metamask-wallet"></a>

Each Tornado Cash Nova account is linked to a shielded address. As mentionned above, users have two ways to access their account & its balance. One of these ways is **through a MetaMask wallet connected to the appropriate shielded address**.

![](https://i.imgur.com/idXaco8.png)

A shielded address is automatically created when users log in a given address, then deposit tokens to funds this address’ pool balance.

_More information about the Funding action is availaible on_ [_Fund & Withdraw on Nova_](fund-and-withdraw-on-nova.md)__

However, shielded addresses can also be created from scratch as a separate action by logging in a new address with no prior link to Tornado Cash Nova, then by clicking on `Set up account`.

By confirming this action through your Metamask account, your shielded address will be crypted & created with the generation of a shielded key.

![](https://i.imgur.com/8q7DYeh.png)

Once the account set, you will be able to receive shielded transfers of tokens from any another address registered to the pool. You will also be able to fund, transfer & withdraw tokens as you wish.

### Shielded Key <a href="#shielded-key" id="shielded-key"></a>

As seen above, the other way to log in is **through the generated Shielded Key** that is created when an account is created through the set up of a new shielded address.

Once you are logged in with your address & your account is set up, you can download this shielded key at any time by accessing your account data (by clicking on your address, next to your shielded balance).

![](https://i.imgur.com/RFac1HU.png)

![](https://i.imgur.com/F2Scf8w.png)

To obtain full privacy, the same good practices that were recommended for traditional Tornado Cash pools are still required. _You can find guidelines to maintain privacy in the protocol’s documentation:_ [_Tips to remain anonymous_](../general/tips-to-remain-anonymous.md) _&_ [_More anonymity tips_](more-anonymity-tips.md)_._

\_\_

_Written by_ [_@ayefda_](https://torn.community/u/ayefda)
