# More Anonymity Tips

For this section, we refer you to the [tips-to-remain-anonymous.md](../general/tips-to-remain-anonymous.md "mention") tutorial as a first step. All points mentioned in this tutorial still apply to Tornado Cash Nova.

As a quick reminder, these tips include:

* Using of a VPN,
* Not sharing the shielded key or the access to this shielded address
* If downloaded, keeping this shielded key in a safe place,
* Deleting data after use,
* Avoiding the use of the same API token for all transactions,
* Being patient between the moment of deposit & withdrawal,
* Using multiple addresses for withdrawal.

However, with its new features, Tornado Cash Nova requires further precautions to maintain anonymity.

## Use of Relayers <a href="#use-of-relayers" id="use-of-relayers"></a>

Gas fees payments are necessary for transactions. For shielded transfers & withdrawals, two payment methods are available to provide ETH for gas fee. You can either **connect your wallet or use a Relayer**.

Going through your wallet for this gas fee can compromise the anonymity of the transaction if used ETH are linkable to your identity. Therefore, **it is recommended to use a Relayer to preserve privacy**

![Tips1](https://i.imgur.com/PsZ89Ym.png)

## Choice of Withdrawal Amounts <a href="#choice-of-withdrawal-amounts" id="choice-of-withdrawal-amounts"></a>

The customized amounts feature offers more flexibility & freedom of usage. However, it can compromise your privacy if used carelessly.

### Choosing predefined amounts for withdrawals <a href="#choosing-predefined-amounts-for-withdrawals" id="choosing-predefined-amounts-for-withdrawals"></a>

![Tips2](https://i.imgur.com/dKYvNQT.png)

Choosing one of the four predefined amounts is strongly recommended as it will allow your withdrawal to blend with the crowd and remain anonymous.

You still have the freedom to `Set custom` to withdraw a customized amount of you choice. However, depending on the chosen amount, a connection might be deduced between your initial fund transaction and your withdrawal if:

* the initially funded amount & the withdrawn amount are exactly the same,
* the funded & withdrawn amounts can easily be linked through a sum.

For instance, a deposit of 0.42 ETH can be linked to a withdrawal of exactly 0.42 ETH or two times 0.21 ETH, which might compromise anonymity. However, with a withdrawal of 0.391 ETH, privacy is better preserved as there is no obvious link between the 0.42 & 0.391 amounts.

The custom option should only be chosen with full knowledge of these facts and in complete confidence in your actions.

_Written by_ [_@ayefda_](https://torn.community/u/ayefda)
